--[[
	Ball class
]]
math.randomseed(os.time())
local ball = {}
ball.__index=ball

function ball.spawn()
	local ball=setmetatable({},ball)
	local dir = math.random(1,10)
	print(dir)
	ball.Direction=dir > 5 and "left" or "right" -- random direction
	ball.Velocity={x=ball.Direction=="left" and -200 or 200,y=0}
	ball.x=400-7.5
	ball.y=300-7.5
	ball.StX=ball.x
	ball.StY=ball.y
	ball.w=15
	ball.h=15
	ball.Speed=200
	return ball
end

function ball:draw()
	love.graphics.rectangle("fill",self.x,self.y,15,15)
end

function ball:reset()
	self.x=self.StX
	self.y=self.StY
	local dir = math.random(1,10)
	self.Direction=dir > 5 and "left" or "right" -- random direction
	self.Velocity={x=self.Direction=="left" and -200 or 200,y=0}
end

function ball:update(dt)
	self.x=self.x+self.Velocity.x*dt
	self.y=self.y+self.Velocity.y*dt
end

function ball:hit(wall,mtv)
	if not wall and mtv then
		self.x = self.x + mtv.x
		self.x = self.x + mtv.y
		self.Velocity.x = -self.Velocity.x
		self.Velocity.y = self.Velocity.y * 0.8 + math.random(-10, 10) / 10 * self.Speed
	end
	if wall then
		self.Velocity.y=-self.Velocity.y
	end
end

return ball