--[[
	Paddle class/module
]]
local paddle = {}
paddle.__index=paddle
function paddle.new(position,ball,ai)
	local paddle = setmetatable({},paddle)
	paddle.ai=ai and true or false  -- auto set to false if ai is not given as an argument
	paddle.aiParameters=paddle.ai and ai or nil
	paddle.x=position.x
	paddle.y=position.y
	paddle.w=10
	paddle.h=80
	paddle.ball=ball
	paddle.savedUpdSpd = paddle.ai and paddle.aiParameters.UpdateSpd or nil
	return paddle
end

function paddle:draw()
	love.graphics.rectangle("fill",self.x,self.y,10,80)
end

function paddle:update(dt)
	if not self.ai then
		if love.keyboard.isDown("w") then
			self.y=self.y-255*dt
		end
		if love.keyboard.isDown("s") then
			self.y=self.y+255*dt
		end
	end
	if self.ai then
		if self.y+(self.h/2) > self.ball.y then
			self.y = self.y - self.aiParameters.Spd * dt
		end
		if self.y+(self.h/2) < self.ball.y then
			self.y = self.y + self.aiParameters.Spd * dt
		end
	end
	if self.y+self.h >= 600 then
		self.y=600-self.h
	end
	if self.y <= 0 then
		self.y=0
	end
end

return paddle