--[[
	Simple pong game created in a day by badfitz66/badfitz67
	
	Collision using minimal translation vector is probably a bit overkill 
	but it was the only thing I could think of that could stop the ball 
	from getting trapped inside the paddle
]]--

local paddle=require("Modules/paddle")
local ballclass=require("Modules/ball")
local col=require("Modules/collision")

function love.load()
	mainFont = love.graphics.newFont("Fonts/BACKTO1982.TTF", 17);
	aiScore=0
	playerScore=0
	ball = ballclass.spawn()
	paddle1=paddle.new({x=10,y=300-50},ball)
	paddle2=paddle.new({x=780,y=300-50},ball,{Spd=225})
end

function love.draw()
	love.graphics.setFont(mainFont)
    love.graphics.print("Player: "..playerScore, 10, 10)
    love.graphics.print("CPU: "..aiScore, 700, 10)
	paddle1:draw()
	ball:draw()
	paddle2:draw()
end
function love.update(dt)
	paddle1:update(dt)
	paddle2:update(dt)
	ball:update(dt)
	local collisionLeft,mtv1=col:collidesMTV(paddle1,ball)
	local collisionRight,mtv2=col:collidesMTV(paddle2,ball)
	if collisionLeft then
		ball:hit(false,mtv1)
	end
	if collisionRight then
		ball:hit(false,mtv2)
	end
	if ball.y <= 0 or ball.y+15>=600 then
		ball:hit(true)
	end
	if ball.x < 0 then
		aiScore=aiScore+1
		paddle1.y=300-50
		paddle2.y=300-50
		ball:reset()
	end
	if ball.x+15 > 800 then
		playerScore=playerScore+1
		paddle1.y=300-50
		paddle2.y=300-50
		ball:reset()
	end
end